/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2013  PCMan <email>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#ifndef FM_EXTERNALTHUMBNAILER_H
#define FM_EXTERNALTHUMBNAILER_H

#include <QObject>
#include <QQueue>
#include "thumbnailer.h"
#include <libfm/fm.h>
#include <QProcess>

namespace Fm {

class ExternalThumbnailerEngine: public ThumbnailerEngine {
Q_OBJECT
  
public:
  ExternalThumbnailerEngine();
  virtual ~ExternalThumbnailerEngine();

  virtual void add(Thumbnailer* thumbnailer);
  virtual void remove(Thumbnailer* thumbnailer);
  virtual bool fileSupported(FmFileInfo* file);

  static ExternalThumbnailerEngine* instance() {
    return instance_;
  }

private:
  QString parseCommand(Thumbnailer* thumbnailer, FmThumbnailer* command);
  void run();
  void runCommand(FmThumbnailer* command);

private Q_SLOTS:

  void onProcessFinished(int exitCode, QProcess::ExitStatus exitStatus);
  void onProcessError(QProcess::ProcessError error);

private:
  // external thumbnailer-based loader
  QQueue<Thumbnailer*> queue;
  QTimer* timeout;
  Thumbnailer* current;
  QProcess currentProcess;
  char* currentUri;
  QString currentOutputFile;
  const GList* currentCommandIter;
  bool isRunning;
  static ExternalThumbnailerEngine* instance_;
};

}

#endif // FM_EXTERNALTHUMBNAILER_H
